Unit MNE1R1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNE1R2_p, MNR1N_p;

procedure MNE1R1(D :Real; F :Real; FE :Real; FUNC :Proc_F1_MN;
                var G :Array of Real; var GE :Array of Real;
                GEN :Real; GN :Real; var GH :Array of Real;
                var H :Real; var IERR :Integer;
                var I0 :Array of Integer; var KF :Integer;
                KFMAX :Integer; N :Integer; SUBG :Proc_F2_MN;
                var X :Array of Real; XEN :Real;
                var XH :Array of Real);

implementation

procedure MNE1R1(D :Real; F :Real; FE :Real; FUNC :Proc_F1_MN;
                var G :Array of Real; var GE :Array of Real;
                GEN :Real; GN :Real; var GH :Array of Real;
                var H :Real; var IERR :Integer;
                var I0 :Array of Integer; var KF :Integer;
                KFMAX :Integer; N :Integer; SUBG :Proc_F2_MN;
                var X :Array of Real; XEN :Real;
                var XH :Array of Real);
var
I,J :Integer;
FH,GHN,GN0 :Real;
label
_10,_20,_30,_40,_50,_60;
begin
{ --------------------------------------------------------- }
{    MNE1R1 OPEEET HAPABEHE YBAH G  BEHY }
{       AA H  TOK X. }
{  HA BXOE:  F,G-HAEHE YHK  CYPAEHTA B T. X, }
{             GN-HOPMA CYPAEHTA; }
{  HA BXOE: G-HAPABEHE YBAH, H-HOBOE HAEHE AA; }
{             IERR=7 -OHAAET,TO HAEHO HAPABEHE Y- }
{                     BAH. }
{ ----------------------------------------------------------- }
{           PRINT 707 }
{ 707       FORMAT (7X,'****') }
for I:=1 to 10000 do
 begin
  for J:=1 to N do
   begin
    XH[J-1] := X[J-1] - H*G[J-1]/GN;
_10:
   end;
  FUNC(XH,FH,FE);
  KF := KF + 1;
  if ( KF <  KFMAX ) 
   then goto _20;
  IERR := 4;
  goto _60;
{  ECT  YBAHE B HAPABEH G C AOM H }
_20:
  if ( F - FH <=  FE ) 
   then goto _30;
{            HAPABEHE YBAH OYEHO: }
  IERR := 7;
  goto _60;
{   EM HAPABEHE YBAH }
_30:
  SUBG(XH,GH,GE,I0);
  MNR1N(GH,N,GHN);
  MNE1R2(N,G,GH);
  GN0 := GN;
  MNR1N(G,N,GN);
  if ( GN <=  GEN ) 
   then goto _40;
{    HET  "CH" BEKTOPOB G  PEHEO G }
  if ( Abs(GN-GN0) >  GEN ) 
   then goto _50;
{         B POTBHOM CYAE - POEHE AA: }
  H := H*D;
  SUBG(X,G,GE,I0);
  MNR1N(G,N,GN);
{          PRINT 309,H }
{  309       FORMAT(2X,'PO. AA- CHE','H=',E7.2) }
  if ( H >  XEN ) 
   then goto _50;
{                   OYEHA TOKA MHMYMA: }
  IERR := 1;
  goto _60;
_40:
{            PRINT 310 }
{ 310        FORMAT('PO.AA, OCTP. HAP. G=0') }
{ ----POEHE AA (TEPA O H E POEH E) }
  H := H*D;
  SUBG(X,G,GE,I0);
  MNR1N(G,N,GN);
  if ( GN >  GEN ) and (  H >  XEN ) 
   then goto _50;
  if ( GN <=  GEN ) 
   then IERR := 3;
  if ( H <=  XEN ) 
   then IERR := 1;
  if ( GN <=  GEN ) and (  H <=  XEN ) 
   then IERR := 13;
  goto _60;
_50:
 end;
_60:
end;

end.
