Unit MNE1R4_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNE1R4(F1 :Real; FE :Real; FUNC :Proc_F1_MN; var G :Array of Real;
                GN :Real; var H :Real; var KF :Integer;
                KFMAX :Integer; N :Integer; var X :Array of Real;
                var XH :Array of Real; var X1 :Array of Real);

implementation

procedure MNE1R4(F1 :Real; FE :Real; FUNC :Proc_F1_MN; var G :Array of Real;
                GN :Real; var H :Real; var KF :Integer;
                KFMAX :Integer; N :Integer; var X :Array of Real;
                var XH :Array of Real; var X1 :Array of Real);
var
I,J :Integer;
FH :Real;
label
_10,_20,_30,_40,_50;
begin
{  /-MA MNE1R4 ET OTPEOK OHOMEPHO MHMA 0,H }
{  HA BXOE: O HAPABEH G C AOM H ECT YBAHE HE }
{            MEHE FE; }
{            KF,KFMAX- KOECTBO BCEH YHK,TEKY- }
{                      EE  MAX AAHHOE. }
{  HA BXOE: }
{            H - HA OTPEKA MHMA 0,H; }
{            X1- PAB KOHE OTPEKA MHMA; }
{            F1- HAEHE YHK B TOKE X1. }
{  PAOE MACCB: XH H N; }
{                   X1 H N (CM. BE). }
{  BXO  --M MNE1R4 B BYX CYAX: }
{       1) HAEH OTPEOK [0,H], COEPA TOKY MH.; }
{        2) BOHEHO MAX KO.-BO BCEH YHK. }
{  CPE APAMETPOB MNE1R4 HET CEAHOO PHAKA,YKA- }
{  BAEO PHY BXOA  --M }
for I:=1 to N do
 begin
  XH[I-1] := X[I-1] - H*G[I-1]/GN;
_10:
 end;
FUNC(XH,FH,FE);
KF := KF + 1;
for I:=1 to 200 do
 begin
_20:
  H := H*2.0;
  for J:=1 to N do
   begin
    X1[J-1] := X[J-1] - H*G[J-1]/GN;
_30:
   end;
  FUNC(X1,F1,FE);
  KF := KF + 1;
  if ( KF >=  KFMAX ) 
   then goto _50;
{            HAEH  PAB KOHE OTPEKA MHMA }
  if ( F1 >  FH ) 
   then goto _50;
  FH := F1;
_40:
 end;
_50:
end;

end.
