Unit MNE1R5_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MMKRIT_p, MNB8R_p, MNE1R2_p, MNE1R3_p, MNE1R4_p, MNR1N_p, UTMN05_p;

procedure MNE1R5(AL :Real; D :Real; var E :Real; var F :Real;
                FE :Real; FUNC :Proc_F1_MN; var G :Array of Real;
                var GE :Array of Real; GEN :Real;
                var GH :Array of Real; GN :Real; var H :Real;
                var IERR :Integer; var I0 :Array of Integer;
                var KF :Integer; KFMAX :Integer; N :Integer;
                SUBG :Proc_F2_MN; T0 :Real; TMAX :Real;
                var X :Array of Real; XEN :Real;
                var XH :Array of Real);

implementation

procedure MNE1R5(AL :Real; D :Real; var E :Real; var F :Real;
                FE :Real; FUNC :Proc_F1_MN; var G :Array of Real;
                var GE :Array of Real; GEN :Real;
                var GH :Array of Real; GN :Real; var H :Real;
                var IERR :Integer; var I0 :Array of Integer;
                var KF :Integer; KFMAX :Integer; N :Integer;
                SUBG :Proc_F2_MN; T0 :Real; TMAX :Real;
                var X :Array of Real; XEN :Real;
                var XH :Array of Real);
var
I,I2,IM,IRR,ITER,ITMAX,J,K,KPR1,MACC,MAXK,PR1,S,S1,KOUNT :Integer;
//A2,DT,F1,F2,FH,FMIN,GHN,GN0,KOUNT,T,XMIN :Real;
A2,DT,F1,F2,FH,FMIN,GHN,GN0,T,XMIN :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250;
begin
{   /-MA MNE1R5 OCYECTBET OCHOBHY POEYPY AOPTMA }
{   KOHHOBA, T.E. CTPOT TEPAOHHY OCEOBATEHOCT }
{   TOEK, KOTOPA OECEBAET YBAHE YHK HA AAH- }
{   HY BEHY. BXO  POEYP - O OCTEH AAH- }
{   HO POMEYTOHO TOHOCT E (O HOPME CYPAEHTA)  }
{   B CEYX CYAX: }
{   IERR=1 - OYEHA TOKA MH. (A H MEHE TOHOCT O }
{            APYMEHTY (O HOPME XEN); }
{    IERR=2 - OCTHYTA AAHHA TOHOCT O YHK (FE); }
{   IERR=4 - BOHEHO KFMAX - MAX KOECTBO BCEH YH- }
{            K; }
{   IERR=5 - CTEKO BPEM TMAX; }
{   IERR=6 - POOO AMEEHE CETA; }
{   IERR=7 - OCTHYTA TOHOCT E }
{           HA BXOE  IERR=8    OHAAET, TO XOT  OHA }
{          YE A BOHEHA SUBR MNE1R5 }
{        APAMETP: }
{     AL - APAMETP "AA" B AOPTME KOHHOBA; }
{     D  - KOHCTAHTA POEH AA H  TOHOCT E; }
{     E  - AAHHA (POMEYTOHA) TOHOCT O HOPME CY- }
{          PAEHTA; }
{     F,G,GN - HAEHE YHK, CYPAEHTA  HOPM CY- }
{              PAEHTA B TOKE X, .T AAH HA BXOE; }
{    FH,GH,GHN - TO E B TOKE XH=X-H*G/GN; }
{    FUNC,SUBG - MEHA OPOPAMM BCEH YHK  }
{                CYPAEHTA; }
{   XEN - TOHOCT (O HOPME) O APYMEHTY; }
{   KF,KFMAX - KOECTBO BCEH YHK, TEKYEE  MAK- }
{              CMAHOE; }
{   T0,TMAX - BPEM, HAAHOE  MAX,OTBEEHHOE  PEEH }
{             AA; }
{   I0 - BEKTOP KCPOBAHHX KOMOHEHT. }
K := 0;
S1 := 0;
KPR1 := 0;
for J:=1 to 10000 do
 begin
{  HE CTEKO  AAHHOE BPEM }
  UTMN05(T);
  DT := T - T0;
  if ( DT <  TMAX ) 
   then goto _10;
  IERR := 5;
  goto _250;
_10:
{              PRINT 29,F,GN }
{ 29   FORMAT(X,'B HA MNE1R5','F=',E12.4,'GN=',E12.3) }
{   EAEM A  TOK X O HAPABEH G BEHO H }
  if ( GN <  GEN ) 
   then goto _250;
  for I:=1 to N do
   begin
    XH[I-1] := X[I-1] - H*G[I-1]/GN;
_20:
   end;
  FUNC(XH,FH,FE);
  KF := KF + 1;
  if ( KF <  KFMAX ) 
   then goto _30;
  IERR := 4;
  goto _250;
_30:
  SUBG(XH,GH,GE,I0);
  MNR1N(GH,N,GHN);
  if ( GHN >  GEN ) 
   then goto _40;
{              OA B TOKY MHMYMA: }
  IERR := 3;
  goto _250;
_40:
{    ECT  OCTATOHOE YBAHE O YHK }
{      YECT FE }
  F2 := F - FH;
  A2 := AL*H*GN;
_50:
{                        PRINT 25,F2,A2 }
{ 25                     FORMAT(2X,'F-FH=',E10.3,2X,'AL*H*GN=',F10.3) }
  if ( Abs(F2) >  FE ) 
   then goto _60;
  S := S + 1;
  if ( S <  5 )
   then goto _70;
  IERR := 2;
  goto _250;
_60:
  S := 0;
_70:
  if ( (F - FH) - AL*H*GN ) < 0
   then goto _80
   else if ( (F - FH) - AL*H*GN ) > 0
         then goto _130
         else goto _130;
{         CTPOM HAPABEHE YBAH: }
_80:
  MNE1R2(N,G,GH);
  S1 := S1 + 1;
{ 211       FORMAT(2X,'GN=',E13.5,'GN0=' E13.5,'GEN='E13.5) }
  GN0 := GN;
  MNR1N(G,N,GN);
  if ( GN - E ) < 0
   then goto _90
   else if ( GN - E ) > 0
         then goto _110
         else goto _90;
{              TOHOCT E O HOPME CYPAEHTA OCTHYTA: }
_90:
  if ( IERR =  8 ) 
   then goto _100;
{ -------EC HE O CBA B YY TOKY,POOAEM }
{        CTPOT HAPABEHE YBAH, }
{     K -  CETK 'YAHX' AOB }
  if ( K <>  0 ) 
   then goto _100;
  E := E*D;
  goto _240;
_100:
  IERR := 7;
  SUBG(X,G,GE,I0);
  MNR1N(G,N,GN);
  goto _250;
{      HET  "CH" BEKTOPOB G  PEYEO G }
_110:
  if ( Abs(GN0-GN) >=  GEN ) 
   then goto _240;
{         PRINT 211, GN,GN0,GEN }
{      B CYAE "CH" - POEHE AA: }
_120:
  H := H*D;
{ --------OHOBEHE: }
  SUBG(X,G,GE,I0);
  MNR1N(G,N,GN);
{            PRINT 333,H,S1 }
  S1 := 0;
{ 333  FORMAT(2X,'POEHE AA',2X,'H=',F12.9,'S1=',I2) }
  if ( H >  XEN )
   then goto _240;
{                       OYEHA TOKA MHMYMA: }
  IERR := 1;
  goto _250;
{  YBAHE O YHK OKAAOC OCTATOHM: }
_130:
{        PRINT 21 }
{ 21     FORMAT(2X,'YBAHE OCTATOHOE') }
  S1 := 0;
{ --------OHOMEPHA MHMA------------------ }
{           IM - KAK ACTO POBOTC OHOMEPHA MH. }
  IM := 2;
  if ( (K Mod IM) <>  0 ) 
   then goto _170;
{           OCK OTPEKA MH- }
{         PRINT 39,H }
{ 39      FORMAT(2X,'H=',E12.3) }
  MNE1R4(F1,FE,FUNC,G,GN,H,KF,KFMAX,N,X,XH,GH);
{                  PRINT 39,H }
  if ( KF <  KFMAX ) 
   then goto _140;
  IERR := 4;
  goto _250;
_140:

{  OHOMEPHA MHMA O HAPABEH G HA OTPEKE [0,H] }
  for I:=1 to N do
   begin
    GH[I-1] := -G[I-1]/GN;
_150:
   end;
  ITMAX := 5;
  MAXK := KFMAX div 20;
  MACC := 1;
  MNB8R(N,X,GH,XH,FUNC,0.0,H,XEN,FE,ITMAX,MAXK,FMIN,
       XMIN,KOUNT,ITER,MACC,IRR);
{         PRINT 400,IRR,ITER,KOUNT,XMIN,FMIN }
{ 400     FORMAT(2X,'IRR=',I3,2X,'ITER=',I4,2X,'KOUNT=',I4, }
{     *2X,'XMIN=',E12.3,2X,'FMIN=',E12.3) }
{     PEYTAT OHOMEPHO MHMA - A H: }
  H := XMIN;
  for I2:=1 to N do
   begin
    X[I2-1] := X[I2-1] - H*G[I2-1]/GN;
_160:
   end;
  F := FMIN;
//  KF := Trunc( KF + KOUNT );
  KF :=  KF + KOUNT;
  if ( KF <  KFMAX )
   then goto _180;
  IERR := 4;
  goto _250;
{ -----------KOHE OHOMEPHO MHMA---- }
_170:
{       EPEXO B HOBY TOKY }
  MNE1R3(N,XH,X);
  F := FH;
_180:
{            B HOBO TOKE: }
  SUBG(X,G,GE,I0);
  MNR1N(G,N,GN);
  K := K + 1;
{      OCTHYTA  TOHOCT E }
  if ( GN - E ) < 0
   then goto _190
   else if ( GN - E ) > 0
         then goto _200
         else goto _190;
_190:
  IERR := 7;
  goto _250;
_200:
  if ( F - FH - FE ) < 0
   then goto _220
   else if ( F - FH - FE ) > 0
         then goto _210
         else goto _220;
_210:
//  S := 0.0;
  S := 0;
  goto _230;
_220:
  S := S + 1;
  if ( S <  5 ) 
   then goto _230;
  IERR := 2;
  goto _250;
_230:
{       POBEPKA, HET  AMEEH CETA }
  MMKRIT(K,F,PR1);
  if ( PR1 =  1 ) 
   then KPR1 := KPR1 + 1;
  if ( KPR1 <=  3 ) 
   then goto _240;
  IERR := 6;
  goto _250;
{  EC AMEEH CETA HET, EPEXOM K CEYE TEPA }
{      O K, T.E. HA KOHE KA: }
_240:
 end;
_250:
end;

end.
