Unit MNR1N_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNR1N(var RV :Array of Real; N :Integer; var Z :Real);

implementation

procedure MNR1N(var RV :Array of Real; N :Integer; var Z :Real);
var
I :Integer;
S,Z1 :Real;
label
_1,_2,_3;
begin

Z := 0.0;
for I:=1 to N do
 begin
  if ( Z >= Abs(RV[I-1]) ) 
   then goto _1;
  Z := Abs(RV[I-1]);
_1:
 end;
if ( Z = 0.0 ) 
 then goto _3;
Z1 := 1.0/Z;
S := 0.0;
for I:=1 to N do
 begin
_2:
  S := S+IntPower(RV[I-1]*Z1,2);
 end;
Z := Sqrt(S)*Z;
_3:
end;

end.
